#ifndef __COMBINE_SEND_RECV
#define __COMBINE_SEND_RECV

#include "arrays.h"
#include "Combine.h"

// for send
int pack_send_CombineItem(CombineItem _item);
int pack_send_RepArray(RepArray * _array);
int pack_send_buffer(void);
int create_type_send(void);
int send_data(int _dest, int _tag, MPI_Comm _comm);
int clear_send(void);

// for recv
int req_recv_CombineItem(void);
int req_recv_RepArray(RepArray * _array);
int unpack_recv_buffer(void);
void * get_rep_start(RepArray * _array);
int create_type_recv(void);
int recv_data(int _source, int _tag, MPI_Comm _comm, MPI_Status * _status);
int clear_recv(void);

extern char recv_buffer[];

#endif
