#ifndef __TREE_BUILDERS
#define __TREE_BUILDERS

#define FLAT 0
#define DARY 1
#define BIO 2

// int round(double _d);

int build_tree(int _nodes, int _rank, int * _parent, 
			   int * _no_children, int ** _children);
void build_d_tree(int lower, int higher, int rank, int * parent,
				  int * no_children, int ** children, int d);
void build_flat_tree(int _nodes, int _rank, int * _parent, 
					 int * _no_children, int ** _children);
void skewed_tree(int _lower, int _higher, double _ratio, int _rank, 
				 int * _parent, int * _no_children, int ** _children);
void skewed_tree_init(int nodes, double ratio, int rank, int * parent, 
					  int * no_children, int ** children);

#endif
